
// (c) COPYRIGHT URI/MIT 1999
// Please read the full copyright statement in the file COPYRIGHT.
//
// Authors:
//      jhrg,jimg       James Gallagher (jgallagher@gso.uri.edu)

// Implementation for the class IDLStructure. See IDLByte.cc
//
// jhrg 9/26/96

// $Log: IDLSequence.cc,v $
// Revision 1.1.2.1  1999/09/23 23:06:30  jimg
// This collection of files builds under Solaris 2.6. The resulting idl_dods.so
// runs correctly on the fnoc1.nc test dataset.
//

#ifdef _GNUG_
#pragma implementation
#endif

#include <assert.h>

#if 0
#include <iostream.h>
#include <Pix.h>
#include <SLList.h>
#endif
#include <string>

#include "debug.h"
#include "IDLSequence.h"
#if 0
#include "name_map.h"
#endif

#if 0
extern name_map names;
extern bool translate;

extern void smart_newline(ostream &os, Type type);
#endif

Sequence *
NewSequence(const string &n)
{
    return new IDLSequence(n);
}

BaseType *
IDLSequence::ptr_duplicate()
{
    return new IDLSequence(*this);
}

IDLSequence::IDLSequence(const string &n) : Sequence(n)
{
}

IDLSequence::~IDLSequence()
{
}

bool 
IDLSequence::read(const string &, int &)
{
    assert(false);
    return false;
}

int
IDLSequence::length()
{
    return -1;
}

// Count the non-ctor elements in the Sequence recurring on embedded
// ctor types.

#if 0
static int
count_elements(IDLSequence *sp, bool flat)
{
    int i = 0;

    for (Pix p = sp->first_var(); p; sp->next_var(p))
	switch (sp->var(p)->type()) {
	  case dods_byte_c:
	  case dods_int16_c:
	  case dods_uint16_c:
	  case dods_int32_c:
	  case dods_uint32_c:
	  case dods_float32_c:
	  case dods_float64_c:
	  case dods_str_c:
	  case dods_url_c:
	    i++;
	    break;

	  case dods_array_c:
	  case dods_list_c:
	  case dods_structure_c:
	  case dods_sequence_c:
	  case dods_grid_c:
	    if (flat)
		i += count_elements((IDLSequence *)sp->var(p), flat);
	    else
		i++;
	    break;

	  default:
	    return 0;
	}

    return i;
}

void 
IDLSequence::print_val(ostream &os, string space, bool print_decls)
{
    // Print the declarations
    os << type_name() << endl << names.lookup(name(), translate);

    int i = count_elements(this, false);
    os << " " << i << endl;

    for (Pix p = first_var(); p; next_var(p)) {
	var(p)->print_val(os, "", print_decls);
	smart_newline(os, var(p)->type());
    }
}

void
IDLSequence::print_all_vals(ostream &os, XDR *src, DDS *dds, string, bool)
{
    // Print the values. Always print decls with the values for writeval.
    print_val(os, "", true);
    while (deserialize(src, dds)) {
	print_val(os, "", true);
    }
}
#endif
