
// (c) COPYRIGHT URI/MIT 1999
// Please read the full copyright statement in the file COPYRIGHT.
//
// Authors:
//      jhrg,jimg       James Gallagher (jgallagher@gso.uri.edu)

// Implementation for the class IDLStructure. See IDLByte.cc
//
// jhrg 1/12/95

// $Log: IDLStructure.cc,v $
// Revision 1.1.2.1  1999/09/23 23:06:32  jimg
// This collection of files builds under Solaris 2.6. The resulting idl_dods.so
// runs correctly on the fnoc1.nc test dataset.
//

#ifdef _GNUG_
#pragma implementation
#endif

#include <assert.h>
#if 0
#include <iostream.h>
#endif
#include <string>

#if 0
#include <Pix.h>
#include <SLList.h>
#endif

#include "IDLStructure.h"

#if 0
#include "name_map.h"
#endif

#if 0
extern name_map names;

extern void smart_newline(ostream &os, Type type);
#endif

Structure *
NewStructure(const string &n)
{
    return new IDLStructure(n);
}

BaseType *
IDLStructure::ptr_duplicate()
{
    return new IDLStructure(*this);
}

IDLStructure::IDLStructure(const string &n) : Structure(n)
{
}

IDLStructure::~IDLStructure()
{
}

// For this `IDL' class, run the read mfunc for each of variables which
// comprise the structure. 

bool
IDLStructure::read(const string &, int &)
{
    assert(false);
    return false;
}

#if 0
void 
IDLStructure::print_val(ostream &os, string space, bool print_decls)
{
    for (Pix p = first_var(); p; next_var(p)) {
	var(p)->print_val(os, "", print_decls);
    }
}

void
IDLStructure::print_all_vals(ostream &os, XDR *src, DDS *dds, string space, 
				bool print_decl_p)
{
    bool sequence_found = false;

    for (Pix p = first_var(); p; next_var(p)) {
	assert(var(p));

	switch (var(p)->type()) {
	  case dods_sequence_c:
	    (dynamic_cast<IDLSequence *>
	     (var(p)))->print_all_vals(os, src, dds, "", print_decl_p);
	    sequence_found = true;
	    break;
	  
	  case dods_structure_c:
	    (dynamic_cast<IDLStructure *>
	     (var(p)))->print_all_vals(os, src, dds, "", print_decl_p);
	    break;
	  
	  default:
	    // If a sequence was found, we still need to deserialize()
	    // remaining vars.
	    if(sequence_found)
		var(p)->deserialize(src, dds);
	    var(p)->print_val(os, "", print_decl_p);
	    break;
	}

	os << endl;
    }
}
#endif
